#!/bin/bash

BUILD_ROOT="|>BUILD_ROOT<|"
BASE_NAME=|>BASE_NAME<|
RUN_PIL_PREP=|>RUN_PIL_PREP<|
PIL_PREP_TOOL=|>PIL_PREP_DIR<|/pilpreptool

allargs=( "$@" )
buildstep=$1
compilerpath=$2
artifactname=$3

#echo $compilerpath

if [ $buildstep -eq 0 ]; then
	if [ $RUN_PIL_PREP -eq 1 ]; then
		echo "prebuild"
		#   Reconstruct the CFLAGS argument, which may be split into multiple
	    #   arguments if there are spaces in include_paths.
	    #   NOTE: This will break if there are other argument separators
	    #         (comma, semicolon, equal sign, tab character) in include_paths.
		CFLAGS=""
		k=3
		while [ $k -lt "$#" ]; do
	#		echo ${allargs[k]}
			if [ "${allargs[k]}" == PLECS_PIL_SEPARATOR ]; then 
				break 
			fi
			if [ $k -eq 3 ]; then
				CFLAGS=${allargs[k]}
			else
				CFLAGS=${CFLAGS}"\\ "${allargs[k]}
			fi
			let k=k+1 
		done
	#	echo ${CFLAGS}
		let k=k+1 #skip PLECS_PIL_SEPARATOR
		# preprocess the sources
		PPFILES=""
		while [ $k -lt "$#" ]; do
	#		echo ${allargs[k]}
			ppcmd="${compilerpath}/bin/cl2000 ${CFLAGS} -DPIL_PREP_TOOL --preproc_only ${allargs[k]// /\\ }"
	#		echo ${ppcmd}
			eval ${ppcmd}
			PPFILES=${PPFILES}" "${allargs[k]// /\\ }
			let k=k+1 
		done	
		prepcmd="${PIL_PREP_TOOL} ${PPFILES//.c/.pp} -k \"cregister __cregister interrupt __interrupt __inline far\" -postfix -o ../cg/pil_symbols"
	#	echo ${prepcmd}
		eval ${prepcmd}
		rm -f ${PPFILES//.c/.pp}
	fi
else
	echo "postbuild"
	cp ${artifactname}.out "${BUILD_ROOT}"/${BASE_NAME}.elf
fi